package ru.soune.nocopy.handler;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;
import ru.soune.nocopy.dto.BaseRequest;
import ru.soune.nocopy.dto.BaseResponse;
import ru.soune.nocopy.dto.MessageCode;
import ru.soune.nocopy.dto.statistic.TokenStatisticResponse;
import ru.soune.nocopy.service.statistic.TokenStatisticService;

@Component
@RequiredArgsConstructor
@Slf4j
public class StatisticTokenHandler implements RequestHandler {
    private final TokenStatisticService statisticService;

    @Override
    public BaseResponse handle(BaseRequest request) throws Exception {
        TokenStatisticResponse statistics = statisticService.getTokenStatistics();

        return new BaseResponse(
                request.getMsgId(),
                MessageCode.SUCCESS.getCode(),
                MessageCode.SUCCESS.getDescription(),
                statistics
        );
    }
}
